/**
 * Boid.Cpp
**/

#include "boid.h"

Boid::Boid()
{
  curr_turning_x = 0;
	curr_turning_y = 0;
}

/**
 * Move the boid one time-step
**/
void Boid::Move()
{
	// Todo: Fix this a little bit 

	// Add to amount boid is currently turning
	curr_turning_y += new_turning_y;
	new_turning_y= 0;
	
	// Make sure boid doesn't turn TOO much!
	if( curr_turning_y > MAX_TURN_SPEED )
		curr_turning_y = MAX_TURN_SPEED;
	else if( curr_turning_y < -MAX_TURN_SPEED )
		curr_turning_y = -MAX_TURN_SPEED;

	// Apply turn amount that has been calculated to actual bird theta...
	theta_y += (int)curr_turning_y + 360;
	theta_y %= 360;

	curr_turning_x += new_turning_x;
	new_turning_x = 0;

	// Make sure boid doesn't turn TOO much!
	if( curr_turning_x > MAX_VERTICAL_ANGLE )
		curr_turning_x = MAX_VERTICAL_ANGLE;
	else if( curr_turning_x < -MAX_VERTICAL_ANGLE )
		curr_turning_x = -MAX_VERTICAL_ANGLE;

	// Now actually turn the darn thing!
	theta_x = (int)curr_turning_x + 360;
	theta_x %= 360;
	
	// Make 15 degree x-rot limits for boid... So it doesn't fly straight up, in loops, etc
	if( (theta_x > MAX_VERTICAL_ANGLE) && (theta_x < 180-MAX_VERTICAL_ANGLE) )
		theta_x = MAX_VERTICAL_ANGLE;
	else if( (theta_x < 360 - MAX_VERTICAL_ANGLE) && (theta_x >= 180-MAX_VERTICAL_ANGLE) )
		theta_x = 360-MAX_VERTICAL_ANGLE;

	z += cos_lookup[theta_y] * velocity;
	y += sin_lookup[theta_x] * velocity; 
	x += sin_lookup[theta_y] * velocity;
	
}

/**
 * Turn this boid towards the desired theta
 * @amount The amount of degrees it can turn
**/
void Boid::TurnTowardsY( int desired_theta, float amount )
{
	// Weird checks because of 360-0 discontinuity
	if( desired_theta > theta_y ) {
		if( theta_y + 180 < desired_theta )
			new_turning_y-= amount;
		else
			new_turning_y+= amount;
	}
	else if( desired_theta < theta_y ) {
		if( theta_y - 180 < desired_theta )
			new_turning_y-= amount;
		else
			new_turning_y+= amount;
	}
	else {
		// Do nothing... We're already there!
	}

}