/**
 * Boid.H
**/

#ifndef BOID__H
#define BOID__H

extern double cos_lookup[360];
extern double sin_lookup[360];

const int MAX_TURN_SPEED = 3;
const int MAX_VERTICAL_ANGLE = 30;		// How much up/down can it fly

class Boid
{
public:
  float x, y, z;		// Position (0-1)
	float velocity;		// How fast is it going? (0-1)
  int theta_y;		// Angle (rotated around y axis) (0-259)
	int theta_x;		// Angle (rotated around x axis) (0-259)
	int state;			// Is it alive? exploding? etc? (1=alive)

	float new_turning_y;		// How much more should the boid turn in one direction this round???
	float curr_turning_y;		// How much is the boid currently turning in one direction???
	
	float curr_turning_x;		// The same, but for going up/down
	float new_turning_x;

	float goal_y;		// How high does the boid want to go?

public:
	Boid();
	void Move();
	void TurnTowardsY(int theta, float amount);

};

#endif