/**
 * Renderer.H
**/

#ifndef RENDERER__H
#define RENDERER__H

#include "world.h"
#include "texture.h"
#include <glut.h>
#include <gl\gl.h>

class Renderer
{
public:
	Renderer();
	~Renderer();
	void InitGLStuff();
	void SetWorld(World *w);
  void RenderWorld();
	float RandFloat();
	void RenderTerrainList();
	void RenderBoidList();

private:
	void RenderBoids();
	void RenderSky();
	void RenderBillboards();
	void RenderFPS();
	void RenderWater();

public:
	// Various params
	int use_fog;
	int use_textures;
	int use_lighting;
	int use_doublebuffer;
	int use_sky;
	int use_billboards;
	int use_fps;
	int use_shadows;
	float LANDCHUNK_WIDTH;

	int depth_flag;		// TEST

private:
	Texture *tex_land;
	World *world;
	unsigned int dl_terrain;	// display list for terrain
	unsigned int dl_boid;			// display list for a single boid
	Texture *tex_cloud;
	Texture *tex_boid;
	Texture *tex_billboards[NUM_BILLBOARD_TYPES];
	Texture *tex_water0, *tex_water1;
};

#endif