/**
 * Terrain.H
**/

#ifndef TERRAIN__H
#define TERRAIN__H

const int TERRAIN_SIZE = 50;			//50
const int SMOOTHNESS = 4;

const int NUM_BILLBOARD_TYPES = 2;// 0=tree, 1=skeleton
const int NUM_BILLBOARDS = 30;

class Billboard
{
public:
	float x,y,z;	// Position
	int type;			
};

/**
 * Holds information about the terrain
 * Hopefully will be fractally generated
**/
class Terrain
{
public:
	Terrain();
	~Terrain();
	void Generate();
	void ExtendInfinite();
	void AddBillboards();
	void FlatGen();
	void RandomGen();

public:
	float heights[TERRAIN_SIZE][TERRAIN_SIZE];     // How high up is this point?
	float tex_x[TERRAIN_SIZE][TERRAIN_SIZE];		// Texture position advancement values
	float tex_y[TERRAIN_SIZE][TERRAIN_SIZE];

	Billboard billboards[NUM_BILLBOARDS];

public:
	int use_flatland;

private:


public:


};

#endif