/**
 * World.H
**/

#ifndef WORLD__H
#define WORLD__H

#include "boid.h"
#include "terrain.h"

const NUM_BOIDS = 40;

const int CAMERA_MANUAL = 0;  // Keyboard movements
const int CAMERA_TOP = 1;  // Top view, looking straight down
const int CAMERA_BIRD = 2;  // Bird's eye view
const int CAMERA_SMART =3;  // Follow the flock a few feet behind them

const float CAMERA_SPEED = 1.0f;

/**
 * Holds information about the world being simulated
**/
class World
{
public:
	Boid *boids;		// Array of boids
	Terrain *terrain;
  float camera_x, camera_y, camera_z;
	int camera_rx, camera_ry;  // Camera rotation degrees (about x and y)
	int camera_mode;

	int keys[200];		// 0=off, 1=on
	int mappoint_x, mappoint_z, mappoint_y;		 // Random destination for the boids to fly to
	// scenery data
	// Moving water theta value

public:
	World();
	~World();
	void UpdateWorld();
	void UpdateCamera();
	void 	ProcessPreBirdMoveKeys();
	void ApplyBoidRules( int b );
	int CalculateInverseTan( double delta_x, double delta_z );
};

#endif